var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useCallback, useEffect, useRef } from "react";
import { waitForScript } from "../scriptloader-support";
export default (function useScriptLoader(config) {
    const { source, onSuccess, onFailure = () => {
        //noop
    }, } = config;
    const isMounted = useRef(true);
    useEffect(() => () => {
        isMounted.current = false;
    }, []);
    const successFunc = useCallback(() => isMounted.current && onSuccess(), [
        onSuccess,
    ]);
    const errorFunc = useCallback((err) => isMounted.current && onFailure(err), [onFailure]);
    useEffect(() => {
        const waitForSource = () => __awaiter(this, void 0, void 0, function* () {
            try {
                yield waitForScript(source);
                successFunc();
            }
            catch (err) {
                errorFunc(err);
            }
        });
        void waitForSource();
    }, [source, successFunc, errorFunc]);
});
